/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * A remotable service interface used for a Callback
 * from Service12 with a function that is not part of the callback interface
 * @author Bryan Aupperle
 *
 */

#include <string>

// @Remotable
class Service12Callback {
public:
	/**
	 * Member function for invoking testcase service
	 * @param input - input parameter(s) as a std::string
	 * @return - output data as a std::string
	 */
	virtual std::string callback1(const std::string input) const = 0;

	/**
	 * Member function for invoking testcase service
	 * @param input - input parameter(s) as a std::string
	 * @return - output data as a std::string
	 */
	virtual std::string callback2(const std::string input) const = 0;

};
