/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/*
 * Exception thrown by SCA Test services
 * @author Bryan Aupperle
 *
 */

#include <string>

// @WebFault(name="TestException", targetNamespace="http://test.sca.oasisopen.org/")
class TestException {
private:
	std::string faultData;
public:
	/**
	 * Constructor with fault message and fault info arguments
	 * @param message - fault message as a string
	 * faultInfo - fault info parameter is missing
	 */
	TestException(const char* message);

	/**
	 * Member function for retrieving fault info
	 * @return - fault info as a std::tring
	 */
	std::string getFaultInfo() const;

};
