/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * Test initiation class with a single reference of multiplicity 1..1
 * @author Bryan Aupperle
 *
 */

#include "CPP_0009_Client.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "oasis/sca/SCAException.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

CPP_0009_Client::CPP_0009_Client() {
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	std::string testName = properties->getString("testName");

	return;
}

CPP_0009_Client::~CPP_0009_Client()
{
	return;
}

std::string CPP_0009_Client::invokeTest(const std::string input) {
	std::string response = "";

	try {
		response = runTest(input);
	} catch (SCAException e) {
		throw new TestException("SCA Runtime Exception", "Test service got an exception during execution: " + *e.getMessageText());
	} // end try
	return response;
}

std::string CPP_0009_Client::runTest(const std::string input) {
	std::string response = "", response1 = "no reference";

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceProxyPtr service = context->getService("reference1");
	if (service) {
		reference1 = dynamicCast<Service1Proxy>(service);

		if (reference1)
			response1 = reference1->operation1(input);

		response = testName + " " + input + " " + response1;
	}
	else
		response = testName + " " + input + " no invocation";


	return response;
}
