/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation with
 * 1 service with interface Service12, which has a callback
 * 0 references
 * @author Bryan Aupperle
 *
 */

#include "Service12Impl.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "oasis/sca/SCAException.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service12Impl::Service12Impl()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service12Impl::~Service12Impl()
{
	return;
}

// Implementation

std::string Service12Impl::operation1(const std::string input) {
	std::string callbackResult = "";

	ComponentContextPtr context = ComponentContext::getCurrent();
	ServiceReferencePtr serviceRef = context->getSelfReference();
	ServiceProxyPtr callback = serviceRef->getCallback();
	callback1 = dynamicCast<Service12CallbackProxy>(callback);

	std::string response = serviceName + " operation1 invoked";

	if (callback1) {
		try {
			callbackResult = callback1->callback1(input);
		} catch (SCAException e) {
			return "Test service got an error during execution";
		} // end try
		response += " " + callbackResult;
	}

	return response;
}
