/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * A test service interface
 * @author Bryan Aupperle
 *
 */

#include <string>
#include <stdint.h>

// @Remotable
class Service19 {
public:
	/**
	 * Member function for invoking testcase service
	 * @param input - input parameter(s) as a std::string
	 * @return - output data as a std::string
	 */
	virtual std::string operation1(const std::string input) const = 0;

	/**
	 * Member function for invoking testcase service
	 * @param index - a by-value parameter
	 * @param size - a by-reference parameter
	 * @param input - input parameter(s) as a string
	 * @return - output data as a short
	 */
	virtual int16_t operation2(int16_t index, int16_t& size, std::string input) const = 0;

};
