/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation
 * 1 service with interface Service1
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl13.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl13::Service1Impl13()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	classStr[0] = 'a';

	return;
}


Service1Impl13::~Service1Impl13()
{
	return;
}

// Implementation
std::string Service1Impl13::operation1(const std::string input) {
	std::string response = serviceName + " operation1 invoked " + classStr;
	classStr[0]++;
	return response;
}
