/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1
 * 1 reference (1..n) with interface Service1
 * all configured wires get called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl19.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl19::Service1Impl19()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service1Impl19::~Service1Impl19()
{
	return;
}

// Implementation

std::string Service1Impl19::operation1(const std::string input) {
	std::string result;

	ComponentContextPtr context = ComponentContext::getCurrent();

	std::vector<ServiceReferencePtr> serviceRef = context->getServiceReferences("reference1");

	reference1.clear();
	ServiceProxyPtr service;
	Service1ProxyPtr reference;
	for(int i = 0; i < serviceRef.size(); i++) {

		service = serviceRef[i]->getService();
		reference = dynamicCast<Service1Proxy>(service);
		if (reference) {
			reference1[i] = reference;
			result.append(reference1[i]->operation1(input));
		}
    }

	return serviceName + " operation1 invoked" + " " + result;
}
