/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation
 * 1 service with interface Service1
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl20.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl20::Service1Impl20()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service1Impl20::~Service1Impl20()
{
	return;
}

// Implementation
typedef RefCountingPointer<int> IntPtr;
typedef RefCountingPointer<long> LongPtr;
typedef RefCountingPointer<int> Int2Ptr;

std::string Service1Impl20::operation1(const std::string input) {
	std::string result;

	int a = 1, *pa = &a;
	long b = 2, *pb = &b;

	IntPtr testa = pa;
	if (*testa == 1)
		result = "a";

	LongPtr testb = pb;
	testa = reinterpretCast<int>(testb);
	if (*testa == 2)
		result.append("b");

	Int2Ptr testc = reinterpret_cast<int>(0);
	testa = staticCast<int>(testc);
	if (!testa)
		result.append("c");

	return serviceName + " operation1 invoked " + result;
}
