/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation
 * 1 service with interface Service1
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl57.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
#include <string>
#include <unistd.h>
using namespace oasis::sca;

std::string flag;

// Construction/Destruction

Service1Impl57::Service1Impl57()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service1Impl57::~Service1Impl57()
{
	return;
}

// Implementation

std::string Service1Impl57::operation1(const std::string input) {
	if (input.at(0) == 'a') {
		flag = "a";
		sleep(2);
	}
	else {
		sleep(1);
		flag = "b";
	}

	return serviceName + " operation1 invoked " + flag;
}
