/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation
 * 1 service with interface Service1
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service1_16Impl.h"
#include "Service16Proxy.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service1_16Impl::Service1_16Impl()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service1_16Impl::~Service1_16Impl()
{
	return;
}

// Implementation

std::string Service1_16Impl::operation1(const std::string input) {
	std::string result;

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceReferencePtr serviceRef = context->getSelfReference("Service16");
	ServiceProxyPtr service = serviceRef->getService();
	Service16ProxyPtr service16 = dynamicCast<Service16Proxy>(service);

	if (service16)
		result = service16->operation2(input);

	return serviceName + " operation1 invoked " + result;
}

std::string Service1_16Impl::operation2(const std::string input) {
	return "operation2 invoked";
}
