/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation
 * 1 service with interface Service21
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service21Impl.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service21Impl::Service21Impl()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service21Impl::~Service21Impl()
{
	return;
}

// Implementation

std::string Service21Impl::operation1(const std::string input) {
	return serviceName + " operation1 invoked";
}

short Service21Impl::operation2(int a, long b, long long c) {
	return 0;
}

unsigned short Service21Impl::operation3(unsigned int a, unsigned long b, unsigned long long c) {
	return 0;
}

unsigned char Service21Impl::operation4(signed char a, char b) {
	return 0;
}

float Service21Impl::operation5(double a, long double b) {
	return 0;
}

int8_t Service21Impl::operation6(int16_t a, int32_t b, int64_t c) {
	return 0;
}

uint8_t Service21Impl::operation7(uint16_t a, uint32_t b, uint64_t c) {
	return 0;
}

wchar_t *Service21Impl::operation8(wchar_t a, commonj::sdo::DataObjectPtr b, const char *c) {
	return L"";
}

bool Service21Impl::operation9(time_t a,  struct tm b) {
	return 0;
}

