/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * A test service interface with a function that is potentially a OneWay MEP
 * @author Bryan Aupperle
 *
 */

#include <string>

// @Remotable
class Service24 {
public:
	/**
	 * Member function for invoking testcase service
	 * @param input - input parameter(s) as a std::string
	 * @return - output data as a std::string
	 */
	virtual std::string operation1(const std::string input) const = 0;

	/**
	 * Member function for invoking testcase service
	 * @param a - float parameter
	 */
	virtual void operation2(float a) const = 0;

};
