/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation with
 * 1 service with interface Service47, which has a callback
 * 0 references
 * @author Bryan Aupperle
 *
 */

#include "Service47Impl.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "oasis/sca/SCAException.h"
#include "commonj/sdo/sdo.h"
#include <unistd.h>
using namespace oasis::sca;

// Construction/Destruction

Service47Impl::Service47Impl()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service47Impl::~Service47Impl()
{
	return;
}

// Implementation

std::string Service47Impl::operation1(const std::string input) {
	std::string callbackResult = "";

	ComponentContextPtr context = ComponentContext::getCurrent();
	ServiceReferencePtr serviceRef = context->getSelfReference();
	ServiceProxyPtr callback = serviceRef->getCallback();
	callback1 = dynamicCast<Service47CallbackProxy>(callback);


	if (callback1) {
		Service47CallbackProxy::callback1ResponsePtr response = callback1->callback1Async(input);
		while (!response->isReady())
			sleep(2);

		// The response is ready and can be accessed without blocking.
		callbackResult = response->getReturn();
	}

	return serviceName + " operation1 invoked" + " " + callbackResult;
}
