/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation with
 * 1 service with interface Service5, which has a callback
 * 0 references
 * @author Bryan Aupperle
 *
 */

#include "Service5Impl.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service5Impl::Service5Impl()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service5Impl::~Service5Impl()
{
	return;
}

// Implementation

std::string Service5Impl::operation1(const std::string input) {
	std::string callbackResult = "";

	ComponentContextPtr context = ComponentContext::getCurrent();
	ServiceReferencePtr serviceRef = context->getSelfReference();
	ServiceProxyPtr callback = serviceRef->getCallback();
	callback1 = dynamicCast<Service5CallbackProxy>(callback);

	if (callback1)
		callbackResult = callback1->callback1(input);

	return serviceName + " operation1 invoked" + " " + callbackResult;
}
