/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service11W
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl14W.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "oasis/sca/SCAException.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl14W::Service1Impl14W()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service1Impl14W::~Service1Impl14W()
{
	return;
}

// Implementation

std::string Service1Impl14W::operation1(const std::string input) {
	std::string result = "";

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceProxyPtr service = context->getService("reference1");
	reference1 = dynamicCast<Service11WProxy>(service);

	std::string response = serviceName + " operation1 invoked";

	if (reference1) {
		try {
			result = reference1->operation1(input);
		} catch (SCAException e) {
			return "Test service got an error during execution";
		} // end try
		response += " " + result;
	}

	return response;
}
