/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service45
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service45Proxy.h"
#include <string>

class Service1Impl52 : public Service1 {
public:
	// @Property
	std::string serviceName;

	// Reference with an implied multiplicity of (1..1) since required=true is the default
	// @Reference(interfaceHeader="Service45.h")
	Service45ProxyPtr reference1;

	Service1Impl52();
	virtual ~Service1Impl52();

	virtual std::string operation1(const std::string input);

};
