/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C++ component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service40
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl47.h"
#include "oasis/sca/RefCountingPointer.h"
#include "oasis/sca/ComponentContext.h"
#include "commonj/sdo/sdo.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl47::Service1Impl47()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	commonj::sdo::DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");

	return;
}


Service1Impl47::~Service1Impl47()
{
	return;
}

// Implementation

std::string Service1Impl47::operation1(const std::string input) {
	std::string result;

	ComponentContextPtr context = ComponentContext::getCurrent();

	ServiceProxyPtr service = context->getService("reference1");
	reference1 = dynamicCast<Service40Proxy>(service);

	if (reference1) {
		commonj::sdo::DataFactoryPtr df = context->getDataFactory();
		commonj::sdo::DataObjectPtr inputDO = df->create("","result");
		inputDO->setString("input", input);
		commonj::sdo::DataObjectPtr resultDO = reference1->operation1(inputDO);
		result = resultDO->getString("result");
	}

	return serviceName + " operation1 invoked" + " " + result;
}
