/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * A test service interface with a function that has a @WebResult annotation
 * @author Bryan Aupperle
 *
 */

#include <string>

// @Remotable
class Service26 {
public:
	/**
	 * Member function for invoking testcase service
	 * @param input - input parameter(s) as a std::string
	 * @return - output data as a std::string
	 */
	virtual std::string operation1(const std::string input) const = 0;

	/**
	 * Function for invoking testcase service
	 * @param input - input parameter(s) as a string
	 * @return - output data as a string but in date format
	 */
	// @WebResult(type="xs:date")
	virtual std::string operation2(const std::string input) const = 0;

};
