/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * A test service interface with a function that has a @WebFunction annotation to disambiguate
 * an overloaded member function
 * @author Bryan Aupperle
 *
 */

#include <string>

// @Remotable
class Service28 {
public:
	/**
	 * Member function for invoking testcase service
	 * @param input - input parameter(s) as a std::string
	 * @return - output data as a std::string
	 */
	virtual std::string operation1(const std::string input) const = 0;

	/**
	 * Member function for invoking testcase service
	 * @param input - input parameter(s) as a float
	 * @return - output data as a std::string
	 */
	// @WebFunction(operationName="operation2")
	virtual std::string operation1(const float input) const = 0;

};
